=== debian/changelog ===
salmon (1.2.1+ds1-1build1) groovy; urgency=medium

  * No-change rebuild against libstaden-read14

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Jun 2020 14:20:11 +0000

salmon (1.2.1+ds1-1) unstable; urgency=medium

  * New upstream version (Closes: #952102)
  * debhelper-compat 12
  * Standards-Version: 4.5.0 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target (routine-
    update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 23 Apr 2020 12:13:04 +0200
