=== debian/control ===
Source: salmon
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-iostreams-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-timer-dev,
               libjellyfish-2.0-dev (>> 2.2.3-2),
               libpthread-stubs0-dev,
               libsparsehash-dev,
               libdivsufsort-dev,
               libbwa-dev,
               pkg-config,
               libjemalloc-dev,
               libcereal-dev,
               libtbb-dev,
               libgff-dev,
               libstaden-read-dev,
               libspdlog-dev,
               libtclap-dev,
               help2man,
               sphinx-doc,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               zlib1g-dev,
               libeigen3-dev,
               libbz2-dev,
               liblzma-dev,
               rapmap-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/salmon
Vcs-Git: https://salsa.debian.org/med-team/salmon.git
Homepage: https://github.com/COMBINE-lab/salmon
Rules-Requires-Root: no

Package: salmon
Architecture: any
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: wicked-fast transcript quantification from RNA-seq data
 Salmon is a wicked-fast program to produce a highly-accurate, transcript-level
 quantification estimates from RNA-seq data. Salmon achieves is accuracy and
 speed via a number of different innovations, including the use of lightweight
 alignments (accurate but fast-to-compute proxies for traditional read
 alignments) and massively-parallel stochastic collapsed variational inference.
 The result is a versatile tool that fits nicely into many different pipelines.
 For example, you can choose to make use of the lightweight alignments by
 providing Salmon with raw sequencing reads, or, if it is more convenient, you
 can provide Salmon with regular alignments (e.g. computed with your favorite
 aligner), and it will use the same wicked-fast, state-of-the-art inference
 algorithm to estimate transcript-level abundances for your experiment.
