=== debian/changelog ===
salmon (1.3.0+ds1-3) unstable; urgency=medium

  * Team upload.
  * Architecture: any-amd64
    Closes: #966430

 -- Andreas Tille <tille@debian.org>  Fri, 14 Aug 2020 12:44:39 +0200

salmon (1.3.0+ds1-2) unstable; urgency=medium

  * Fix the build by adding a missing include.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 28 Jul 2020 14:50:48 +0200

salmon (1.3.0+ds1-1) unstable; urgency=medium

  * Add a patch for portable pausing in spinlocks.
  * debian/upstream/metadata: link to upstream's repository
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * kseq patch no longer needed
  * Refreshed remaining patches

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 16 Jul 2020 13:54:17 +0200
