=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: salmon
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
+Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                libboost-filesystem-dev,
                libboost-system-dev,
@@ -21,7 +21,7 @@
                libjemalloc-dev,
                libcereal-dev,
                libtbb-dev,
-               libgff-dev,
+               libgff-dev (>> 2.0),
                libstaden-read-dev,
                libspdlog-dev,
                libtclap-dev,
@@ -41,7 +41,7 @@
 Rules-Requires-Root: no
 
 Package: salmon
-Architecture: any
+Architecture: any-amd64
 Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
