## salmon 1.4.0+ds1

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,21 @@
 enable_testing()
 
 project(Salmon)
+
+# detect host architecture 
+if(NOT DEFINED USE_ARM)
+  if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64.*|AARCH64.*|arm64.*|ARM64.*)")
+    message("Detected 64-bit ARM host. Setting USE_ARM to true.")
+    set(USE_ARM TRUE)
+    # set char to be signed
+    add_compile_options(-fsigned-char)
+    set(SCHAR_FLAG "-fsigned-char")
+  else()
+    message("Detected non-ARM host. Setting USE_ARM to false.")
+    set(USE_ARM FALSE)
+    set(SCHAR_FLAG "")
+  endif()
+endif()
 
 option(USE_SHARED_LIBS "Use shared instead of static libraries" OFF)
 
@@ -66,9 +81,8 @@
 message(STATUS "CMAKE_BUILD_TYPE = ${CMAKE_BUILD_TYPE}")
 
 ## Set the standard required compile flags
-# Nov 18th --- removed -DHAVE_CONFIG_H
 set(REMOVE_WARNING_FLAGS "-Wno-unused-function;-Wno-unused-local-typedefs")
-set(TGT_COMPILE_FLAGS "-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW;-D__STDC_FORMAT_MACROS")
+set(TGT_COMPILE_FLAGS "${SCHAR_FLAG};-ftree-vectorize;-funroll-loops;-fPIC;-fomit-frame-pointer;-O3;-DNDEBUG;-DSTX_NO_STD_STRING_VIEW;-D__STDC_FORMAT_MACROS")
 set(TGT_WARN_FLAGS "-Wall;-Wno-unknown-pragmas;-Wno-reorder;-Wno-unused-variable;-Wreturn-type;-Werror=return-type;${REMOVE_WARNING_FLAGS}")
 #set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
 #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")
@@ -212,7 +226,7 @@
     set(WARNING_IGNORE_FLAGS "${WARNING_IGNORE_FLAGS} -Wno-unused-local-typedefs")
     set(BOOST_TOOLSET "${CC}")
     set(BOOST_CONFIGURE_TOOLSET "--with-toolset=gcc")
-    set(BCXX_FLAGS "${CXXSTDFLAG}")
+    set(BCXX_FLAGS "${CXXSTDFLAG} ${SCHAR_FLAG}")
     set(BOOST_EXTRA_FLAGS toolset=${CC} cxxflags=${BCXX_FLAGS})
 # Tentatively, we support clang now
 elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
@@ -225,7 +239,7 @@
       list(APPEND TGT_COMPILE_FLAGS -stdlib=libc++)
       set(BOOST_TOOLSET "clang")
       set(BOOST_CONFIGURE_TOOLSET "--with-toolset=clang")
-      set(BCXX_FLAGS "-stdlib=libc++ -DBOOST_HAS_INT128")
+      set(BCXX_FLAGS "-stdlib=libc++ -DBOOST_HAS_INT128 ${SCHAR_FLAG}")
       set(BOOST_EXTRA_FLAGS toolset=clang cxxflags=${BCXX_FLAGS} linkflags="-stdlib=libc++")
     # Otherwise, use libstdc++ (and make it static)
     else()
@@ -358,11 +372,3 @@
   DOWNLOAD_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external
   ##
   DOWNLOAD_COMMAND curl -k -L http://tukaani.org/xz/xz-5.2.2.tar.gz -o xz-5.2.2.tar.gz &&
-    ${SHASUM} 73df4d5d34f0468bd57d09f2d8af363e95ed6cc3a4a86129d2f2c366259902a2 xz-5.2.2.tar.gz &&
-    tar -xzvf xz-5.2.2.tar.gz
-  #URL http://tukaani.org/xz/xz-5.2.2.tar.gz
-  #URL_HASH SHA1=14663612422ab61386673be78fbb2556f50a1f08
-  ##
-  SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/xz-5.2.2
-  INSTALL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/install
-  BUILD_IN_SOURCE TRUE
