=== debian/changelog ===
salmon (1.4.0+ds1-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debian/patches/portable_pause: remove, applied upstream
  * debian/patches/spelling: remove, applied upstream
  * debian/patches/include_fix: remove, applied upstream
  * Refreshed remaining patches
  * debian/control: build-dep on libsimde-dev, build for arm64
  * debian/patches/spelling: new typo fixes

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 26 Nov 2020 19:10:46 +0100
