=== debian/control ===
--- 
+++ 
@@ -33,15 +33,16 @@
                libeigen3-dev,
                libbz2-dev,
                liblzma-dev,
-               rapmap-dev
-Standards-Version: 4.5.0
+               rapmap-dev,
+               libsimde-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon
 Rules-Requires-Root: no
 
 Package: salmon
-Architecture: any-amd64
+Architecture: any-amd64 arm64
 Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
