## salmon 1.5.2+ds1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,8 @@
 set (SALMON_ALIGN_SRCS
 FASTAParser.cpp
 AlignmentModel.cpp
+ONTAlignmentModel.cpp
+AlignmentCommon.cpp
 FragmentLengthDistribution.cpp
 SalmonQuantifyAlignments.cpp
 BAMUtils.cpp
@@ -58,6 +60,7 @@
 
 set (SALMON_LIB_SRCS
 ${GAT_SOURCE_DIR}/src/jellyfish/mer_dna.cc
+backtrace.cc
 xxhash.c
 TranscriptGroup.cpp
 EffectiveLengthStats.cpp
