=== debian/changelog ===
salmon (1.5.2+ds1-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * d/u/metadata: Added ref to SciCrunch (SCR_017036)

  [ Andreas Tille ]
  * Build-Depends: python3-docs-theme and use this instead of furo

 -- Andreas Tille <tille@debian.org>  Mon, 11 Oct 2021 09:38:42 +0200
