=== debian/control ===
--- 
+++ 
@@ -29,13 +29,14 @@
                sphinx-doc,
                python3-sphinx,
                python3-sphinx-rtd-theme,
+               python3-docs-theme,
                zlib1g-dev,
                libeigen3-dev,
                libbz2-dev,
                liblzma-dev,
                rapmap-dev,
                libsimde-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon
