## salmon 1.6.0+ds1

=== debian/changelog ===
salmon (1.6.0+ds1-1ubuntu2) kinetic; urgency=medium

  * debian/patches/glibc-2.34.patch: compatibility with glibc 2.34.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 20 Aug 2022 09:32:13 +0000

salmon (1.6.0+ds1-1ubuntu1) jammy; urgency=medium

  * Build-depend on libtbb2-dev instead of libtbb-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 12:07:23 +0100

salmon (1.6.0+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Mon, 13 Dec 2021 15:41:10 +0100
