=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: salmon
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
@@ -12,7 +13,7 @@
                libboost-thread-dev,
                libboost-program-options-dev,
                libboost-timer-dev,
-               libjellyfish-2.0-dev (>> 2.2.3-2),
+               libjellyfish-2.0-dev,
                libpthread-stubs0-dev,
                libsparsehash-dev,
                libdivsufsort-dev,
@@ -20,7 +21,7 @@
                pkg-config,
                libjemalloc-dev,
                libcereal-dev,
-               libtbb-dev,
+               libtbb2-dev,
                libgff-dev (>> 2.0),
                libstaden-read-dev,
                libspdlog-dev,
@@ -44,10 +45,10 @@
 
 Package: salmon
 Architecture: any-amd64 arm64
-Built-Using: ${sphinxdoc:Built-Using}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Description: wicked-fast transcript quantification from RNA-seq data
  Salmon is a wicked-fast program to produce a highly-accurate, transcript-level
  quantification estimates from RNA-seq data. Salmon achieves is accuracy and
