## salmon 1.9.0+ds1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,7 @@
+if(${TBB_FOUND})
+  get_target_property(TBB_INCLUDE_DIRS TBB::tbb INTERFACE_INCLUDE_DIRECTORIES)
+endif()
+
 include_directories(
 ${GAT_SOURCE_DIR}/include
 ${GAT_SOURCE_DIR}/include/eigen3
@@ -93,10 +97,15 @@
   set_property(TARGET ksw2pp PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
 endif()
 
-set ( UNIT_TESTS_SRCS
+set (UNIT_TESTS_ENTRY_SRCS
     ${GAT_SOURCE_DIR}/tests/UnitTests.cpp
-    FragmentLengthDistribution.cpp
-    ${GAT_SOURCE_DIR}/external/install/src/pufferfish/rank9b.cpp
+)
+
+set (UNIT_TESTS_INDIVIDUAL_SRCS
+  ${GAT_SOURCE_DIR}/src/FragmentLengthDistribution.cpp
+  ${GAT_SOURCE_DIR}/external/install/src/pufferfish/rank9b.cpp
+  ${GAT_SOURCE_DIR}/tests/GCSampleTests.cpp
+  ${GAT_SOURCE_DIR}/tests/LibraryTypeTests.cpp
 )
 
 
@@ -186,7 +195,13 @@
   set_property(TARGET salmon PROPERTY INTERPROCEDURAL_OPTIMIZATION True)
 endif()
 
-add_executable(unitTests ${UNIT_TESTS_SRCS})
+add_library(UnitTestsMain STATIC ${UNIT_TESTS_ENTRY_SRCS})
+target_compile_options(UnitTestsMain PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
+target_compile_options(UnitTestsMain PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
+
+add_executable(unitTests ${UNIT_TESTS_INDIVIDUAL_SRCS} ${GAT_SOURCE_DIR}/tests/catch.hpp)
+target_compile_options(unitTests PUBLIC "$<$<CONFIG:DEBUG>:${TGT_DEBUG_FLAGS}>")
+target_compile_options(unitTests PUBLIC "$<$<CONFIG:RELEASE>:${TGT_RELEASE_FLAGS}>")
 
 #add_executable(salmon-read ${SALMON_READ_SRCS})
 #set_target_properties(salmon-read PROPERTIES COMPILE_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBPTHREAD -D_PBGZF_USE -fopenmp"
@@ -202,10 +217,17 @@
 #  message ("Setting libdivsufsort64 = ${SUFFARRAY_LIB64}") 
 #endif()
 
-
+add_dependencies(salmon puffer)
+add_dependencies(salmon twopaco)
+add_dependencies(salmon graphdump)
+add_dependencies(salmon ntcard)
+add_dependencies(salmon ksw2pp)
+add_dependencies(salmon salmon_core)
+add_dependencies(salmon alevin_core)
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
 # Link the executable
 target_link_libraries(salmon
-    Threads::Threads
+    Threads::Threads 
     puffer 
     salmon_core
     twopaco
@@ -216,32 +238,41 @@
     ${ICU_LIBS}
     ${STADEN_LIBRARIES} ${CURL_LIBRARIES}
     ${ZLIB_LIBRARY}
-    #${SUFFARRAY_LIB}
-    #${SUFFARRAY_LIB64}
-    #${GAT_SOURCE_DIR}/external/install/lib/libbwa.a
     m
     ${LIBLZMA_LIBRARIES}
     ${BZIP2_LIBRARIES}
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
     ksw2pp
-## PUFF_INTEGRATION    
     alevin_core
     ${ASAN_LIB}
     ${FAST_MALLOC_LIB}
-    ${TBB_LIBRARIES}
+    TBB::tbb
+    TBB::tbbmalloc
     ${LIBRT}
     ${CMAKE_DL_LIBS}
-    #ubsan
-)
-
-# Link the executable
+)
+endif()
+
+# dependencies for unitTests
+add_dependencies(salmon salmon_core)
+add_dependencies(salmon alevin_core)
+add_dependencies(unitTests UnitTestsMain)
+#add_dependencies(salmon puffer)
+#add_dependencies(salmon twopaco)
+#add_dependencies(salmon graphdump)
+#add_dependencies(salmon ntcard)
+#add_dependencies(salmon ksw2pp)
+
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
+
 target_link_libraries(unitTests
     Threads::Threads
 ## PUFF_INTEGRATION
+    salmon_core
     alevin_core
-    salmon_core
     gff
+    UnitTestsMain
     ${STADEN_LIBRARIES} 
     ${Boost_LIBRARIES}
     ${ICU_LIBS}
@@ -250,7 +281,9 @@
     m
     ${LIBLZMA_LIBRARIES}
     ${BZIP2_LIBRARIES}
-    ${TBB_LIBRARIES}
+    #${TBB_LIBRARIES}
+    TBB::tbb
+    TBB::tbbmalloc
     ${LIBSALMON_LINKER_FLAGS}
     ${NON_APPLECLANG_LIBS}
     ${ASAN_LIB}
@@ -258,6 +291,7 @@
     ${CMAKE_DL_LIBS}
     #ubsan
 )
+endif()
 
 if(NOT Iconv_IS_BUILT_IN)
   target_link_libraries(unitTests Iconv::Iconv)
@@ -265,6 +299,8 @@
 endif()
 
 add_dependencies(salmon unitTests)
+add_dependencies(unitTests salmon_core)
+add_dependencies(unitTests alevin_core)
 
 ##
 # External dependencies of salmon_core and salmon
@@ -276,18 +312,16 @@
 endif()
 
 if (${FETCHED_BOOST})
-## PUFF_INTEGRATION
-#   add_dependencies(alevin_core libboost)
    add_dependencies(alevin_core libboost)
    add_dependencies(salmon_core libboost)
    add_dependencies(salmon libboost)
 endif()
 
 if (${FETCHED_TBB})
+   message("Fetched oneTBB, so libtbb must be a dependency for targets")
    add_dependencies(alevin_core libtbb)
    add_dependencies(salmon_core libtbb)
-## PUFF_INTEGRATION
-#   add_dependencies(alevin_core libtbb)
+   add_dependencies(unitTests libtbb)
    add_dependencies(salmon libtbb)
 endif()
 
@@ -361,41 +395,18 @@
 set(INSTALL_BIN_DIR bin )
 set(INSTALL_INCLUDE_DIR include )
 
-install(DIRECTORY
-        ${GAT_SOURCE_DIR}/external/install/lib/
-        DESTINATION ${INSTALL_LIB_DIR}
-	    FILES_MATCHING PATTERN "libtbb*.${SHARED_LIB_EXTENSION}*"
-    )
-
-# install(FILES ${Boost_LIBRARIES}
-# 	           DESTINATION ${INSTALL_LIB_DIR})
-
-install(TARGETS salmon salmon_core
-                RUNTIME DESTINATION bin
-                LIBRARY DESTINATION lib
-                ARCHIVE DESTINATION lib
-        )
-
-add_custom_command(TARGET unitTests POST_BUILD
-    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:unitTests> ${GAT_SOURCE_DIR}/tests/$<TARGET_FILE_NAME:unitTests>
-    COMMENT "Copying unitTests"
-)
-
-set(POST_INSTALL_SCRIPT ${GAT_SOURCE_DIR}/cmake/PostInstall.cmake)
-
-install(
-    CODE
-    "
-    execute_process(COMMAND \"${CMAKE_COMMAND}\"
-                            -DCMAKE_SYSTEM_NAME=${CMAKE_SYSTEM_NAME}
-                            -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
-                            -P \"${POST_INSTALL_SCRIPT}\")
-    "
-)
-
-include(InstallRequiredSystemLibraries)
-add_test( NAME unit_tests COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/UnitTests.cmake )
-add_test( NAME salmon_read_test_quasi COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonQuasi.cmake )
-
-# Remove this test since we are removing support for the FMD index. 
-# add_test( NAME salmon_read_test_fmd COMMAND ${CMAKE_COMMAND} -DTOPLEVEL_DIR=${GAT_SOURCE_DIR} -P ${GAT_SOURCE_DIR}/cmake/TestSalmonFMD.cmake )
+if(TBB_RECONFIGURE OR TBB_TARGET_EXISTED)
+#set(TBB_SOURCE_DIR $<TARGET_FILE:TBB::tbb>)
+#add_custom_target(genexdebug COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_LINKER_FILE:TBB::tbb>")
+get_target_property(TBB_LIB_INSTALL_NAME TBB::tbb IMPORTED_LOCATION_RELEASE)
+get_filename_component(TBB_LIB_INSTALL_DIR ${TBB_LIB_INSTALL_NAME} DIRECTORY)
+message("TBB_LIB_INSTALL_DIR = ${TBB_LIB_INSTALL_DIR}")
+file(GLOB TBB_FILES ${TBB_LIB_INSTALL_DIR}/libtbb*.${SHARED_LIB_EXTENSION}*)
+message("TBBGLOBS = ${TBB_FILES}")
+
+install(FILES 
+  ${TBB_FILES}
+  DESTINATION ${INSTALL_LIB_DIR}
+) 
+#install(FILES 
+#  $<TARGET_FILE:TBB::tbbmalloc>
