=== debian/changelog ===
salmon (1.9.0+ds1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version  (Closes: #1008254)

  [ Étienne Mollier ]
  * Standards-Version: 4.6.1 (routine-update)
  * Refresh use_debian_packaged_libs.patch, disable-version-check.patch and
    spelling patch.
  * d/external/: bump pufferfish version to support onetbb.  (Closes: #1011662)
  * d/external/: update twopaco to fix ftbfs with onetbb.
  * d/external/install/: update to reflect changes in embedded pufferfish.
  * Unvendor embedded cereal in embedded pufferfish.  (Closes: #1008252)
  * verbose-test.patch: make test failures more verbose.
  * d/salsa-ci.yml: disable run on i386

 -- Étienne Mollier <emollier@debian.org>  Sat, 05 Nov 2022 20:45:44 +0100
